	;
	; LOD Player Version 2
	;
	; This code will not compile standalone,
	; it must be included and called.
	;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

; Variables
base = $50
SPCH1		= base + $00	; start of channel data patter pointers
SPCH2		= base + $02
PCH1		= base + $04	; channel data pattern pointers
PCH2		= base + $06
CH1		= base + $08	; channel data pointers
CH2		= base + $0A

TICK1		= base + $0C	; fine tick counters
TICK2		= base + $0D
NOTE1		= base + $0E	; note counters
NOTE2		= base + $0F
NOTELEN1	= base + $10	; current note lengths
NOTELEN2	= base + $11

INS_TYPE1	= base + $12
INS_TYPE2	= base + $13
TONE1		= base + $14
TONE2		= base + $15
TONE_PREV1	= base + $16
TONE_PREV2	= base + $17
ARP_CNT1	= base + $18
ARP_CNT2	= base + $19

VOL_TAB		= base + $1A ; 16 bit

NOISE		= base + $1C
;VOLUME		= base + $1D 
VOLTAB_CNT	= base + $1E
VIB		= base + $1F

; COMMAND BYTES

END_MARK	= $FF
;RETRIG		= $FE
SET_VOLTAB	= $FD
;SET_SLIDE	= $FC
SET_ARP		= $FB
SETINS		= $F0
SETVOL		= $E0
SETLEN		= $40

; Constants
base_note = -5 ; shift to F0
C0	= base_note + 0
Ci0	= base_note + 1	
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

OFF	= 71

;-----

	jmp PLAYER_INIT
	jmp PLAYER

freqs	
	db $07,$00,$40,$00,$76,$00,$A9,$00,$D9,$00,$06,$01,$31,$01,$59,$01
	db $7F,$01,$A3,$01,$C5,$01,$E5,$01,$04,$02,$20,$02,$3B,$02,$54,$02
	db $6C,$02,$83,$02,$98,$02,$AD,$02,$C0,$02,$D2,$02,$E3,$02,$F3,$02
	db $02,$03,$10,$03,$1E,$03,$2A,$03,$36,$03,$42,$03,$4C,$03,$56,$03
	db $60,$03,$69,$03,$71,$03,$79,$03,$81,$03,$88,$03,$8F,$03,$95,$03
	db $9B,$03,$A1,$03,$A6,$03,$AB,$03,$B0,$03,$B4,$03,$B9,$03,$BD,$03
	db $C0,$03,$C4,$03,$C7,$03,$CB,$03,$CE,$03,$D0,$03,$D3,$03,$D6,$03
	db $D8,$03,$DA,$03,$DC,$03,$DE,$03,$E0,$03,$E2,$03,$E4,$03,$E5,$03
	db $E7,$03,$E8,$03,$EA,$03,$EB,$03,$EC,$03,$ED,$03,$EE,$03,$FE,$03
 
PLAYER_INIT
	ldx #Channel1 & 255
	ldy #Channel1 >> 8
	jsr set_ch1
	;
	ldx #Channel2 & 255
	ldy #Channel2 >> 8
	jsr set_ch2
	;
	jsr reset_ch1
	jsr reset_ch2
	;
	ldx #Channel1_repeat & 255
	ldy #Channel1_repeat >> 8
	jsr set_ch1
	;
	ldx #Channel2_repeat & 255
	ldy #Channel2_repeat >> 8
	jsr set_ch2
	;
	jsr advance_ch1
	jsr advance_ch2
	;
	ldx #$FF
	stx VOLTAB_CNT
	inx
	stx NOTE1
	stx NOTE2
	;STX VOLUME
	inx
	stx NOTELEN1
	stx NOTELEN2
	inx
	;
	rts

reset_ch1
	ldx SPCH1
	ldy SPCH1 + 1
	stx PCH1
	sty PCH1 + 1
	rts
	
res_1	jsr reset_ch1
	;
advance_ch1
	ldy #$01
	lda (PCH1),y	; HI byte
	beq res_1
	sta CH1 + 1
	dey
	lda (PCH1),y	; LO byte
	sta CH1
	;
	lda PCH1
	clc
	adc #$02
	sta PCH1
	bcc *+4
	inc PCH1+1
	;
	rts
	
set_ch1
	stx SPCH1
	sty SPCH1 + 1
	rts

reset_ch2
	ldx SPCH2
	ldy SPCH2 + 1
	stx PCH2
	sty PCH2 + 1
	rts
	
res_2	jsr reset_ch2
	;
advance_ch2
	ldy #$01
	lda (PCH2),y
	beq res_2
	;
	sta CH2 + 1
	;
	dey
	lda (PCH2),y
	sta CH2
	;
	lda PCH2
	clc
	adc #$02
	sta PCH2
	bcc *+4
	inc PCH2+1
	;
	rts

set_ch2
	stx SPCH2
	sty SPCH2 + 1
	rts

	;
	;##################
	;

PLAYER
	; *** uncomment this to debug
;	DEC $FF19
;	JSR call_player
;	INC $FF19
;	RTS
;call_player
	;------------------
	inc NOTE1
	inc ARP_CNT1
	;
	lda NOTE1
	cmp NOTELEN1
	beq next_note1
	jmp channel2
	;
new_pattern1
	jsr advance_ch1
	;
next_note1
	ldy #$00
	sty NOTE1		; reset note counter
	sty TICK1
	sty ARP_CNT1		; reset arp counter
	;
	lda (CH1),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	beq new_pattern1
	;
	cmp #$FD
	bne pl_11
	;
	lda #$FF		; reset voltab counter
	sta VOLTAB_CNT
	;STA VOLUME		; disable SET volume
	;
	lda (CH1),y		; get lo byte
	sta VOL_TAB
	iny
	;
	lda (CH1),y		; get hi byte
	sta VOL_TAB+1
	iny
	;
	lda (CH1),y		; get byte
	iny
	;
pl_11	
;	cmp #$FC
;	bne pl_12
;	;
;	lda (CH1),y		; get SLIDE lo byte
;	sta slide
;	iny
;	;
;	lda (CH1),y		; get SLIDE hi byte
;	sta slide+1
;	iny
;	;
;	lda (CH1),y		; get byte
;	iny
	;
;pl_12
;	cmp #SET_ARP
;	bne pl_14
;	;
;	lda (CH1),y		; get arp lo byte
;	sta arp_ptr1+1
;	iny
;	;
;	lda (CH1),y		; get arp hi byte
;	sta arp_ptr1+2
;	iny
;	;
;	lda (CH1),y		; get byte
;	iny
	;
pl_14
	cmp #$F0		; instrument change?
	bcc pl_01
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE1   	; store instrument type
	;
	lda (CH1),y		; get byte
	iny
	;
pl_01	
;	CMP #$E0
;	BCC pl_05
;	;
;	AND #$0F
;	STA VOLUME		; store direct volume set value
;	;
;	LDA (CH1),y		; get byte
;	INY
;	;
;pl_05	
	cmp #$50		; set note length?
	bcc pl_02
	;
	sec
	sbc #$50
	sta NOTELEN1
	;
	lda (CH1),y
	iny
	;
pl_02	; - store note!
	;
	ldx TONE1		; keep previous
	stx TONE_PREV1
	sta TONE1
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH1
	sta CH1
	bcc noi_1
	inc CH1 + 1
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel2
	inc NOTE2
	inc ARP_CNT2
	;
	lda NOTE2
	cmp NOTELEN2
	beq next_note2
	bne pl_50
	;
new_pattern2
	jsr advance_ch2
	;
next_note2
	ldy #$00
	sty NOTE2		; reset note counter
	sty TICK2
	sty ARP_CNT2		; reset arp counter
	;
	lda (CH2),y		; get byte
	iny
	;
;	CMP #$FE		; this was used as a test: place $FE (just any flag really)
;	BNE no_stop_flag	; anywhere into the music, and the player will stop there
;	JMP *			; used to make sure certain parts kick in at certain frames
;no_stop_flag
	;
	cmp #END_MARK		; $FF goes to new pattern
	beq new_pattern2
	;
;	cmp #SET_ARP
;	bne pl_24
;	;
;	lda (CH2),y		; get arp lo byte
;	sta arp_ptr2+1
;	iny
;	;
;	lda (CH2),y		; get arp hi byte
;	sta arp_ptr2+2
;	iny
;	;
;	lda (CH2),y		; get byte
;	iny
	;
pl_24	cmp #$F0		; instrument change?
	bcc pl_21
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE2   	; store instrument type
	;
	lda (CH2),y		; get byte
	iny
	;
pl_21	
;	CMP #$E0
;	BCC pl_25
;	;
;	AND #$0F
;	STA VOLUME
;	;
;	LDA (CH2),y		; get byte
;	INY
;	;
;pl_25	
	cmp #$50		; set note length?
	bcc pl_22
	;
	sec
	sbc #$50
	sta NOTELEN2
	;
	lda (CH2),y
	iny
	;
pl_22	; - store note!
	;
	ldx TONE2
	stx TONE_PREV2
	sta TONE2
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH2
	sta CH2
	bcc noi_2
	inc CH2 + 1
noi_2	;     
	;
	;    
pl_50	ldy VOLTAB_CNT
	iny
	lda (VOL_TAB),y
	bpl noi_3		; check for $FF
	ldy #$00		; reached, so warp
noi_3	sty VOLTAB_CNT
	;
	; --- SOUND PROCESSING
	;
PLAYER_SOUND
	lda #$20		; assume no noise
	sta NOISE
	;
	
	;
	ldx #$00		; channel 0
	jsr sound
	;
	sta F1LO
	sty F1HI_x+1
	;
	lda F1HI
	and #$FC
F1HI_x	ora #$00
	sta F1HI
	;
	ldx #$01		; channel 1
	jsr sound
	sta F2LO
	sty F2HI
	;
	; ---
	;    
	inc TICK1
	inc TICK2
	;
	; ---
	;
	lda F1LO
	cmp #$FE
	bne pl_70
	lda F2LO
	cmp #$FE
	beq pl_71
	;
pl_70	ldy VOLTAB_CNT
	lda (VOL_TAB),y		; nope, read from envelope
	ora #$10
	ora NOISE
setvol	sta $FF11
	;
pl_71	
	rts     
	;
inst_table
	dw normal, bassdrum, hihat, snare, vibrato
	dw snare_noise, snare2
	;
sound	lda TONE1,x
	cmp #OFF
	beq lookup
	;
	lda INS_TYPE1,x
	asl a
	tay
	lda inst_table,y
	sta inst_jump+1
	lda inst_table+1,y
	sta inst_jump+2
	;
inst_jump
	jmp $0000
	;
normal	lda TONE1,x		; normal note
lookup	asl a
	tax
	lda freqs,x
	ldy freqs+1,x
	rts
	
;arp	ldy ARP_CNT1,x		; load current arp counter
;	;
;	cpx #$00		; check which channel
;	beq arp_ptr1
;arp_ptr2
;	lda arpeggio,y		; for channel 2 (self-mod)
;	jmp arp_1
;arp_ptr1
;	lda arpeggio,y		; for channel 1 (self-mod)
;arp_1
;	bpl arp_add		; check for negative numbers
;	;
;	and #$0F		; low byte is new position
;	sta ARP_CNT1,x
;	jmp arp			; again!
;	;
;arp_add
;	clc
;	adc TONE1,x
;	jmp lookup
	
;slider	
;	lda TICK1,x
;	bne add1
;	;
;	lda slide
;	ldy slide+1
;	rts
;	;
;add1	lda TONE1,x
;	asl a
;	tax
;	ldy freqs+1,x
;	lda freqs,x
;	clc
;	adc #$01
;	bcc sl_03
;	iny
;sl_03	rts

bassdrum
	lda TICK1,x
	asl a
	tax
	lda bass_freq+1,x
	and #$E0
	sta NOISE
	lda bass_freq+1,x
	and #$03
	tay
	lda bass_freq,x
	rts
	
hihat
	lda #$40
	sta NOISE
	;
	lda TONE1,x		; look up note freq
	asl a
	tax
	lda freqs+1,x
	tay
	lda freqs,x
	;
	rts
	
snare_noise	
	lda TICK1,x
	and #$01
	bne ns1
	;
	lda #$40
	sta NOISE
	;
	lda TICK1,x
	tax
	lda snare_noise_freq+1,x
	tay
	lda snare_noise_freq,x
	rts
	;	
ns1	lda TONE1,x
	asl a
	tax
	lda freqs,x
	ldy freqs+1,x
	rts

snare
	lda TICK1,x
	asl a
	tax
	lda snare_freq+1,x
	and #$E0
	sta NOISE
	lda snare_freq+1,x
	and #$03
	tay
	lda snare_freq,x
	rts
	
snare2
	lda TICK1,x
	asl a
	tax
	lda snare2_freq+1,x
	and #$E0
	sta NOISE
	lda snare2_freq+1,x
	and #$03
	tay
	lda snare2_freq,x
	rts
	
;tom
;	lda TONE1,x		; look up note freq
;	asl a
;	tay
;	;
;	lda TICK1,x
;	asl a
;	tax
;	lda tom_freq,x	; 16 bit add: add snare freq
;	clc
;	adc freqs,y       
;	pha
;	lda tom_freq+1,x
;	adc freqs+1,y
;	tay
;	pla
;	rts
	
;vibX	lda NOTE1,x
;	and #$0F
;	tay
;	lda vibrato2,y
;	bmi vib_sub1
;	bpl vib_add
;
vibrato
	lda NOTE1,x
	and #$0F
	bne vib_1
	;
	ldy #$A0
	sty NOISE
	;
vib_1	tay
	lda TONE1,x
	cmp #$10
	bcc vib_2
	;
	lda vibrato_table_2,y
	bmi vib_sub
	bpl vib_add
	;
vib_2	lda vibrato_table_1,y
	bmi vib_sub
	;
vib_add
	sta VIB
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs+1,x
	lda freqs,x
	clc
	adc VIB
	bcc *+3
	iny
	rts
	;
vib_sub
	and #$7F
	sta VIB
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs+1,x
	lda freqs,x
	sec
	sbc VIB
	bcs *+3
	dey
	rts

	align 256	
vibrato_table_1
	db $0C,$14,$19,$1C
	db $19,$14,$0C,$00
	db $8C,$94,$99,$9C
	db $99,$94,$8C,$00
	
vibrato_table_2
	db $01,$01,$02,$02
	db $02,$01,$01,$00
	db $81,$81,$82,$82
	db $82,$81,$81,$00
	
vibrato_table_3
	db $02,$03,$04,$05
	db $04,$03,$02,$00
	db $82,$83,$84,$85
	db $84,$83,$82,$00

;glide_2	jmp normal
;
;glide	lda TICK1,x
;	beq glide_1
;	;
;	;
;	;
;	cmp #$04			; change this to determine glide length
;	bcs glide_2			; should be power of two, adjust 24 bit div below to match
;	;
;	lda glide_add
;	bmi glide_sub
;	;
;	lda glide_freq_current
;	clc
;	adc glide_freq_diff
;	sta glide_freq_current
;	lda glide_freq_current+1
;	adc glide_freq_diff+1
;	sta glide_freq_current+1
;	lda glide_freq_current+2
;	adc glide_freq_diff+2
;	sta glide_freq_current+2
;	;
;	lda glide_freq_current+1
;	ldy glide_freq_current+2
;	;
;	rts
;	;
;glide_sub
;	lda glide_freq_current
;	sec
;	sbc glide_freq_diff
;	sta glide_freq_current
;	lda glide_freq_current+1
;	sbc glide_freq_diff+1
;	sta glide_freq_current+1
;	lda glide_freq_current+2
;	sbc glide_freq_diff+2
;	sta glide_freq_current+2
;	;
;	lda glide_freq_current+1
;	ldy glide_freq_current+2
;	;
;	rts
;	;
;	; first iteration
;	;
;glide_1	lda TONE1,x			; look up destination freq
;	asl a
;	tay
;	lda freqs,y
;	sta glide_freq_dest+1
;	lda freqs+1,y   
;	sta glide_freq_dest+2
;	;
;	lda TONE_PREV1,x		; look up previous freq
;	asl a
;	tay
;	lda freqs,y
;	sta glide_freq_current+1
;	lda freqs+1,y   
;	sta glide_freq_current+2
;	;
;	lda #$00             		; clear low bytes of 24 bit values
;	sta glide_freq_dest
;	sta glide_freq_current
;	sta glide_freq_diff
;	;
;	lda TONE1,x
;	cmp TONE_PREV1,x
;	bcs glide_down
;	;
;	; up
;	;
;	lda glide_freq_dest+1		; diff = dest - current
;	sec 
;	sbc glide_freq_current+1
;	sta glide_freq_diff+1
;	lda glide_freq_dest+2
;	sbc glide_freq_current+2
;	sta glide_freq_diff+2
;	;
;	lda #$00
;gl_up	sta glide_add
;	;
;	lsr glide_freq_diff+2		; 24 bit div routine
;	ror glide_freq_diff+1
;	ror glide_freq_diff		; div2
;	lsr glide_freq_diff+2
;	ror glide_freq_diff+1
;	ror glide_freq_diff		; div4
;	;lsr glide_freq_diff+2
;	;ror glide_freq_diff+1
;	;ror glide_freq_diff		; div8
;	;
;	lda glide_freq_current+1
;	ldy glide_freq_current+2
;	;
;	rts
;
;glide_down
;	lda glide_freq_current+1	; diff = current - dest
;	sec
;	sbc glide_freq_dest+1
;	sta glide_freq_diff+1
;	lda glide_freq_current+2
;	sbc glide_freq_dest+2
;	sta glide_freq_diff+2
;	;
;	lda #$80     
;	bne gl_up			; always jump
;
;glide_freq_current
;	db 0,0,0	; 24 bit values
;glide_freq_dest
;	db 0,0,0
;glide_freq_diff
;	db 0,0,0
;glide_add
;	db 0
	


;	
;vibrato2
;	;DB 4,3,$83,$84,$84,$83,3,4
;	;DB $6,$3,$83,$86,$86,$83,$3,$6
;	db $7F,$00,$87,$00
;	db $07,$00,$87,$00
;	db $07,$00,$87,$00
;	db $07,$00,$87,$00
;
;slide
;	dw $03FE
;	dw 1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1
;	dw 1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1

snare_noise_freq
	dw $03E8,0
	dw $03E0,0
	dw $03D8,0
	dw $03D0,0
	dw $03C8,0
	dw $03C0,0
	dw $03B8,0
	dw $03B0,0

snare_freq
	dw $43d9
	dw $2280
	dw $43d8
	dw $2240
	dw $43d7
	dw $2200
	dw $43d6
	dw $21c0
	dw $43d5
	dw $2180
	dw $43d4
	;
snare2_freq
	dw $43F9
	dw $43F1
	dw $43E9
	dw $43E1
	dw $43D9
	dw $43D1
	dw $43C9
	dw $43C1
	dw $43B9
	dw $43B1
	dw $43A9
	;
bass_freq
	dw $20C0
	dw $43C8
	dw $2080
	dw $43C6
	dw $2040
	dw $43C4
	dw $2020
	dw $43C2
	dw $2014
	dw $2011
	dw $2007
	                   
;vol_default
;	db 8,$FF
